
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="theme-color" content="#000000">
    <meta name="author" content="Torbjorn Ludvigsen">
    <meta name="keywords" content="Hangprinter, open source, hardware, technology, software, Reprap, development">
    <meta name="description" content="Hangprinter">
    <meta property="og:type" content="website">
    <meta property="og:title" content="Hangprinter">
    <meta property="og:url" content="https://hangprinter.org/FAQ">
    <meta property="og:description" content="Cable Driven RepRap">
    <meta property="og:image" content="https://hangprinter.org/hangprinter4_small.jpeg">
    <meta name="twitter:card" content="summary">
    <meta name="twitter:site" content="@tobbelobb">
    <meta name="twitter:creator" content="@tobbelobb">
    <link rel="stylesheet" href="../style.css?v=0" type="text/css">
    <link rel="apple-touch-icon" sizes="180x180" href="../apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="../favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="../favicon-16x16.png">
    <link rel="manifest" href="../site.webmanifest">
    <link rel="mask-icon" href="../safari-pinned-tab.svg" color="#5bbad5">
    <meta name="msapplication-TileColor" content="#00aba9">
    <meta name="theme-color" content="#ffffff">
    <title>Hangprinter|FAQ</title>
  </head>
  <body style="width:100%;">
    <div class="masthead">
      <h3 class="masthead-brand">
        <a href="../" style="text-decoration:none;color:#000;">
          <img src="../safari-pinned-tab.svg" style="height:50px;width:50px;" />
        </a>
      </h3>
      <nav>
        <ul>
          <li>
            <div class="dropdown">
              <button class="dropbtn">Documentation</button>
              <div class="dropdown-content">
                <a href="../doc/v3">Hangprinter version 3</a>
                <a href="../doc/v4">Hangprinter version 4</a>
              </div>
            </div>
          </li>
          <li><a href="../contribute">Contribute</a></li>
          <li><a href="../about">About</a></li>
          <li><a href="." class="active">FAQ</a></li>
          <li><a href="../resources">Resources</a></li>
          <li><a href="../newsletter">Newsletter</a></li>
        </ul>
      </nav>
    </div>
    <div id="SiteName" style="text-align:center;font-size:20px;">
      Frequently Asked Questions
    </div>
    <div id="MainContent">
<p>
  <b>Q:</b> What is Hangprinter?<br />
  <b>A:</b> A cable driven RepRap 3d printer.
</p>

<p>
  <b>Q:</b> What is the Hangprinter Project? <br />
  <b>A:</b> The Hangprinter Project develops and spreads the unique motion system.
</p>

<p>
  <b>Q:</b> What can a Hangprinter do? <br />
  <b>A:</b> It can use existing structures, like walls and ceilings, as its frame.
  Framelessness makes Hangprinter relatively a cheap, and relatively small/compact.
  It also enables very large prints.
</p>

<p>
  <b>Q:</b> What's the goal and purpose with Hangprinter? <br />
  <b>A:</b>
  The Hangprinter Project wants to design and spread a robot that makes its owners free and independent.
  More in <a href="https://torbjornludvigsen.com/blog/2021/#personal_2">this blog post</a>.
</p>
<p>
  I write a lot about this on my personal blog. See recent bloggy masterpieces such as <a href="https://torbjornludvigsen.com/blog/2021/#hangprinter_project_76">Where Should Open Source Go?</a>,  <a href="https://torbjornludvigsen.com/blog/2021/#hangprinter_project_75">Hopes, Dreams, and Agendas</a>, and <a href="https://torbjornludvigsen.com/blog/2021/#personal_2">Philosophy of Hangprinter</a>.
</p>
<p>
  Some design goals I've stuck to for the last three years are outlined in <a href="https://torbjornludvigsen.com/blog/2018/#hangprinter_project_59">this blog post</a>.
</p>
<p>
  An explanation of the connection with democracy is outlined in <a href="https://torbjornludvigsen.com/blog/2017/#hangprinter_project_50">this blog post</a>.
</p>
<p>
  Other formulations of my personal motivation for working with RepRap are found in my thesis work. See <a href="https://torbjornludvigsen.com/blog/2016/#masters_2">this blog post</a>
  and <a href="https://torbjornludvigsen.com/blog/2016/#masters_1">this blog post</a>.
</p>


<p>
  <b>Q:</b> How do I get one? <br />
  <b>A:</b> Currently, the only option is to source and build oneself.
  The <a href="https://hangprinter.org/doc/v4">documentation</a> contains some guidance, but you'll probably need
  ask questions in the project's <a href="https://hangprinter.org/resources">channels</a>.
</p>

<p>
  <b>Q:</b> What does it cost? <br />
  <b>A:</b> Parts for a v4 costs a grand total of ~$2350. (That's in Sweden, incl vat and other taxes, shipping, and all optional parts, no clones. It's also with low effort put into finding the cheapest parts. I did the experiment.)
</p>

<p>
  <b>Q:</b> Can I cut cost by... <br />
  <b>Sub Q:</b> ... using cheaper lines? <br />
  <b>A:</b> Definitely. We need stiff and light lines, but if your machine is small, and has a light tool head, and if reliability is of lower importance to you then you might not need all the performance the Garda lines give.
  HP3 used Fireline 0.5 mm, which worked ok.
  If you want to help update the BOM for everyone, then order some Garda and compare your line to its stiffness.
  Cheaper lines for everyone would be awesome.
  For reference, <a href="https://youtu.be/K_fQpvZ3oeA">here</a> is how the current Garda lines were compared to Fireline 0.5.<br />
  <b>Sub Q:</b>  ... skipping the ODrives? <br />
  <b>A:</b> Sure, you can use any motor and driver setup. The ODrives are connected to the Duet via a CAN bus which gives torque mode and encoder readings, which gives a lot of everyday convenience as well as auto calibration of anchor locations.
  They also have many nice features like anti-cogging and input filtering that might get important depending on your use case. <br />
  <b>Sub Q:</b>  ... using some other board than the Duet3? <br />
  <b>A:</b> Yes. Reprapfirmware has up to date Hangprinter support for all Duet boards. There's also an unsupported ReprapFirmware version that let's you use Duet2 Wifi and UART to talk with old ODrivefirmware versions.
  At the time of writing only Duet3 has the CAN support, but a cheaper Duet with CAN is in the pipeline.
  Marlin also has Hangprinter support which was in active use up until 2018.
  Marlin's current state is a bit unknown to me (tobben, Oct, 2021).<br />
  <b>Sub Q:</b>  ... skipping the Raspberry Pi 4? <br />
  <b>A:</b> Yes. You'll miss the web interface and the ability to use hp-mark in a standard way.
  <b>Sub Q:</b>  ... Using a cheaper BLDC motor/encoder pair? <br />
  <b>A:</b> Absolutely. This shouldn't affect any functionality except motor performance.
</p>

<p>
  <b>Q:</b> Will kits be available? <br />
  <b>A:</b> No plans for kit supplying are currently known.
</p>

<p>
  <b>Q:</b> Should I build v3 or v4? <br />
  <b>A:</b> I (tobben) recommend the v4.
  It is a more practical and useable machine overall.
</p>

<p>
  <b>Q:</b> How can I contribute? <br />
  <b>A:</b> See the <a href="https://hangprinter.org/contribute">contribute page</a>.
</p>

<p>
  <b>Q:</b> What license is the project under? <br />
  <b>A:</b> Hangprinter (the repo) is under GPLv2, line-collision-detector is GPLv3, hp-mark is GPLv3, auto-calibration-simulation is MIT,
  ODrivefirmware is MIT, RepRapFirmware is GPLv3, and most of hangprinter.org is MIT, except the docs, which is GPLv2.
  That is not the full picture, it gets more complicated if you look closely at the repos.
</p>
<p>
  With that said, I made Hangprinter so people could use it and build businesses around it.
  If any of the licenses above are problematic for your business or project, try contacting me (tobben) in person and let's discuss it.
</p>

<p>
  <b>Q:</b> How large can it print? <br />
  <b>A:</b> It depends.
  Check out <a href="https://torbjornludvigsen.com/blog/2020/#hangprinter_project_63">this blog post</a> for more details.
</p>

<p>
  <b>Q:</b> What materials can it print? <br />
  <b>A:</b> Hangprinter is compatible with most tool heads on the market.
  This includes thermoplastics, but also ceramics and other paste tool heads.
  There's also a pen holder tool head in the repo.
</p>

<p>
  <b>Q:</b> What's the precision? <br />
  <b>A:</b> The proper answer is very complex, so I'll skip it here.
  You should expect similar print surface quality as you get from other 3d printers.
</p>

<p>
  <b>Q:</b> What's the accuracy? <br />
  <b>A:</b> The proper answer requires direct measurement on each machine, and it will be different in different parts of the build volume.
  A computer vision system called <a href="https://gitlab.com/tobben/hp-mark">hp-mark</a> has been developed.
  It wants to bring good accuracy measurements, as well as other good things, to every Hangprinter.
</p>

<p>
  <b>Q:</b> Can you put a 3d scanner on it? <br />
  <b>A:</b> Probably yes.
  I haven't tried because I don't now of practical ways to use Hangprinter as a 3d scanner.
  My main concern is about lines touching the unknown object.
</p>

<p>
  <b>Q:</b> What are Hangprinter's strengths? <br />
  <b>A:</b>
  <ul>
    <li>Big print volume. </li>
    <li>Low price. </li>
    <li>High print speeds. </li>
    <li>Relatively low energy usage of 600W compared to other robots of similar size, eg robot arms.</li>
    <li>Light. Does not require a truck to move to a new location. </li>
    <li>Compact when idle. Parks in the ceiling while not in use, freeing up the floor space below it. </li>
    <li>Compatibility. Runs stock firmwares, tool heads, and slicer settings. </li>
    <li>Silent operation. </li>
    <li>Powerful. Uses very strong motors compared to what small 3d printers use. </li>
    <li>Self-replicates. Can print many of its own parts. </li>
    <li>Low alignment requirements. Uses computer vision to measure actual angles rather than assume perfect angles, if hp-mark is installed and used, that is. </li>
    <li>Open source. All of it's development files, as well as their history, are freely available. This includes hardware and software. </li>
    <li>Actively maintained. </li>
    <li>Known accuracy, once hp-mark is installed.</li>
  </ul>
</p>

<p>
  <b>Q:</b> What are the known limitations? <br />
  <b>A:</b> None. Ok, just kidding.
  <ul>
    <li><b>Space Usage During Operation</b>. The Hangprinter is not box shaped. It takes up a large tetrahedron shaped volume during operation.
      That's the main trade-off the Hangprinter makes. It can become better than boxed in machines in every other metric, but it will never be as compact during operation as a robot arm or a
      cartesian gantry style machine is.</li>
    <li><b>Line Buildup</b>. Spools are constructed in a way that lets line build up in several layers on the spool, often called "spool buildup".
      The simple spool design keeps price and part count low, and reliability high.
      However, the spool buildup is currently not perfectly measured and compensated.
    </li>
    <li><b>No Line Flex Compensation</b>. The firmware assumes the whole drive train to be perfectly stiff, which is obviously not the case in reality.
    Consequences are observable when some lines are very tight, like when heavy tool heads are used and when the tool is far from the origin.</li>
    <li><b>Unknown Line Tension</b>. Hangprinter currently doesn't measure tension in the lines. This data is required to make a perfect flex compensation model, and to make more reliable motor config tuning and fault detection.</li>
    <li><b>Small Dev Team</b>. The lion's share of development is done by a single person. This puts a rather low max cap on dev velocity. </li>
    <li><b>Limited Documentation</b>. Hangprinter v4 has been under heavy development for over a year (as of July 2021), and documentation is consequently behind.
    Use the Project's social channels actively, and ask your questions explicitly, as the doc-situation gradually improves. </li>
  </ul>
  Needless to say, I'm constantly working on, and prioritizing between, the various weak spots of the Project.
</p>
<p>
  <b>Q:</b> What problems does the computer vision system (hp-mark) solve? <br />
  <b>A:</b> Here are some previous limitations that are currently melting away due to hp-mark getting better.
  <ul>
    <li><b>A Rather Involved Calibration Process</b>. Can be fully automated with hp-mark. Currently requires some human assistance.</li>
    <li><b>Unknown Accuracy</b>. Unless hp-mark or another measurement system is installed and used, that is. </li>
    <li><b>The Tilt Problem</b>. Small uncontrollable rotations of effector occur due to line buildup and other things.
        hp-mark measures correct nozzle positions even when effector is tilted, so this can be detected and compensated.</li>
  </ul>
</p>
<p>
  <b>Q:</b> What problem does the line-collision-detector solve? <br />
    The Hangprinters' downwards pointing lines (A, B, and C) can collide with half finished prints during print.
    However, with a specially developed tool called <a href="https://gitlab.com/hangprinter/line-collision-detector">line-collision-detector</a>
    it's quick and easy to run a simulation and see if a collision will occur or not.
    A full simulation typically takes 10 seconds or less to execute.
    It allows you to specify a safety margin, and can output an stl that shows exactly where on your model
    an eventual collision would happen.
</p>
<p>
  <b>Q:</b> How is the project funded? <br />
  <b>A:</b> Ca 10% via donations. The rest via my (tobben's) private money.</p>

<p>
  <b>Q:</b> Why is this not patented? <br />
  <b>A:</b> Hangprinter is designed to be self-replicating, and to be flexible.
  As much as I want to make money and to privatize my ideas,
  the current patent system would limit users too much.
  As everyone else in open source hardware, I'm looking for alternative ways forwards.
  I'm occasionally writing about this on my personal blog. See for example <a href="https://torbjornludvigsen.com/blog/2021/#hangprinter_project_75">here</a> and <a href="https://torbjornludvigsen.com/blog/2021/#hangprinter_project_76">here</a>.
</p>

<p>
  <b>Q:</b> How do you slice for Hangprinter? <br />
  <b>A:</b> Similar to other 3d printers. For some slicing config suggestions, look at <a href="https://gitlab.com/tobben/prusaslicer-configs">tobbens PrusaSlicer configs</a>.
</p>

<p>
  <b>Q:</b> How can I contact you?<br />
  <b>A:</b> See the <a href="https://hangprinter.org/resources/">resources page</a>.
  Personal and private contact details are hard to find on purpose.
  I enjoy being hard to find.
</p>

<p>
  <b>Q:</b> What is the Project's history? <br />
  <b>A:</b> See the <a href="https://hangprinter.org/about/">about page</a>. For a deeper dive, check out my personal <a href="https://torbjornludvigsen.com/blog/#Links">dev blog archives</a>, and the past <a href="../newsletter">newsletters</a>.
</p>

<p>
  <b>Q:</b> Does the print head rotate? <br />
  <b>A:</b> In general, no. See "tilt problem" above, for one exception.
</p>

<p>
  <b>Q:</b> How are rotations avoided? <br />
  <b>A:</b> By keepings pairs/triples of lines parallel and equally long. See <a href="https://youtu.be/QUyifkpk6KY">this Youtube video</a> for a visual explanation.
</p>

<p>
  <b>Q:</b> How should I configure RepRapFirmware for Hangprinter v4? <br />
  <b>A:</b> Check out the example config.g in the repo. It should be somewhere under firmware/RepRapFirmware/Duet3 or similar. </p>

<p>
  <b>Q:</b> How do I find correct bulidup factor (M666 Q-parameter)? <br />
  <b>A:</b>
The buildup factor determines how much firmware should try to compensate for line buildup on the spools.
Theoretical, but a bit naive buildup factor calculation (assumes cylindrical, straight line):
<ul>
  <li>Assume line diameter: 0.5 mm</li>
  <li>Assume spool height: 8.0 mm</li>
</ul>

Buildup factor is equal to (line_cross_section_area)/(height * pi):<br />
((0.5/2) * (0.5/2) * pi)/(8.0 * pi) = 0.0078 mm<br />

In practice, you might want a bit more or a bit less than the naive theoretical calculation gives you.
I don't have a good procedure to fine tune it though, and it doesn't make too big of a difference.

I'm planning and hoping that auto-calibration-simulation-for-hangprinter becomes the default way to do anchor calibration. It will spit out the buildup factor, and hopefully the user shouldn't need to know what it is or how it was calculated.
</p>

<p>
  <b>Q:</b> Should I use steppers or BLDC motors? <br />
  <b>A:</b> Short answer:
            The default for HP4 is BLDCs.
            See the <a href="https://docs.google.com/spreadsheets/d/1_mMTEF9ZFapn_3FrBvEydh70IPTaQG9gKZ7IVj9G2uM/edit#gid=0">BOM</a> for the exact model.
</p>
<p>
Longer answer:
Four really beefy steppers with SmartStepper would do as good a job as the four BLDCs at a slightly lower price tag, for a small and light Hangprinter.
The Hangprinter application lies right between the sweet spot for steppers and the sweet spot for BLDC application.
The bigger and heavier your Hangprinter is, the more BLDC starts to make sense.
</p>
<p>
I often hear the importance of travel speed being plaid down.
Personally, after some long prints, and tens of kilometres of travel moves, I'm willing to pay for fast travels.
It shortens print time, but also improves print quality a lot, since it limits ooze problems.
</p>

<p>
  <b>Q:</b> I want to manually calibrate my anchor locations. How do I do that? <br />
  <b>A:</b> Just a warning: it's hard to get right. After releasing the HP3,
  got so many questions about this that I decided to develop auto calibration as fast as possible.
  Auto calibration now works far better than I've ever managed to hand calibrate.
</p>
<p>
  But back to the question: Check out <a href="https://gitlab.com/tobben/hangprinter/-/issues/35">this discussion</a>.
  Also see <a href="https://reprap.org/wiki/Links_Into_Hangprinter_v3_Build_Video#Now_going_into_an_hour_of_measuring_this">these comments and timestamps of a live streamed HP3 calibration</a>.
</p>

<p>
  <b>Q:</b> Is torque mode neccesary? <br />
  <b>A:</b> Torque mode saves in a lot of manual effort during daily use of the Hangprinter.
  With that said, it's totally possible to tighten lines with the <a href="https://gitlab.com/tobben/hangprinter/-/blob/version_4/firmware/RepRapFirmware/Duet3/macros/Individual_motor_control">Individual_motor_control</a> macro.
  Advanced: If you want a new position to be calculated after the individual motor move, you could also use G1 H2-moves directly.
  Look in the macro or <a href="https://duet3d.dozuki.com/Wiki/G1">ReprapFirmware's gcode docs</a> for details about how G1 H2 is used.
</p>


<!--h3>Common ideas</h3>
<p>
  Cable driven robotics is a field with low hanging fruit.
  Many good ideas have not yet been tested or built.
  Few people have relevant practical experience, so I thought I might offer some of mine below.
  Apply my advice at your own risk.
</p>

<p>
  <b>Q:</b> Having three high anchors and no low anchors. <br />
  <b>A:</b> Pros:
  <ul>
    <li>Reaches a large build volume, without risk of line colliding with print</li>
    <li>Nothing except print surface needs to be installed on the floor. The rest can all reside in the ceiling.</li>
  </ul>
  Cons:
  <ul>
    <li>Limits acceleration severly. The machine will be very slow compared to Hangprinter.</li>
    <li>Doesn't constrain upwards motion. The print head will be pushed around by various tiny forces during print, and will not be able to maintain good accuracy or precision.</li>
  </ul>
</p>

<p>
  <b>Q:</b> Swap one motor with passive elements, like springs, balloons, or counter weights. <br />
  <b>A:</b> </p>

<p>
  <b>Q:</b> Making print head very heavy, for stability. <br />
  <b>A:</b> </p>

<p>
  <b>Q:</b> Other kinds of wires. Steel, nylon, fishing lines, etc. <br />
  <b>A:</b> </p>

<p>
  <b>Q:</b> Force sensors along lines. <br />
  <b>A:</b> </p>

<p>
  <b>Q:</b> Low anchors that move upwards during print. <br />
  <b>A:</b> </p>

<p>
  <b>Q:</b> Having one motor in each anchor. <br />
  <b>A:</b> </p-->

    </div>
    <script data-goatcounter="https://hangprinter.goatcounter.com/count"
            async src="//gc.zgo.at/count.js"></script>
  </body>
</html>
